rm(list=ls())
source("lmfirth.r")

# generate data
set.seed(1234) 
dat=gendata(50, 4, 4) 
S=dat$S
X=dat$X
lev=3

# MLE 
estlm=est_lm_cov_manifest(S,X,lev,4,1,mod=0,out_se=TRUE)

# failure of the MLE 
w=which(apply(estlm$J,1,sum)==0) 
det(estlm$J[-w,-w])

# pMLE
inits=est_lm_cov_manifest(S,X,lev,4,1,mod=0,maxit=0)
inits$be=c(1,1)
estf=lmFirth(S,X,lev,4,init=5,inits=inits)

# pMLE ok 
det(estf$J)

